image: node:14.16.0

before_script:
    - git config --global user.name "Manticore Labs"
    - git config --global user.email "info@manticore-labs.com"
    - cd catalogo
    - npm i
    - 'command -v ssh-agent >/dev/null || ( apt-get update -y && apt-get install openssh-client -y )'
    # - eval $(ssh-agent -s)
    # - echo "$SSH_BACKEND_KEY" | tr -d '\r' | ssh-add -
    # - echo "$SSH_BACKEND_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan gitlab.com >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts

stages:
  - test
  - deploy



lint:
  stage: test
  only:
    - testing
    - master
  script:
    - echo "lint corriendo"
    - npm run lint



deploy_testing:
  stage: deploy
  only:
    - testing
  script:
    - apt-get update -y -qq
    - apt-get -y install rsync -qq
    - apt-get install sshpass
    - cd ..
    - cd ci-cd
    - npm i
    - MLAB_DP_CREAR=$DP_CREAR_TESTING MLAB_DP_SER_LOG=$DP_SER_LOG_TESTING MLAB_DP_CONJ=$DP_CONJ_TESTING MLAB_DP_SUBCONJ=$DP_SUBCONJ_TESTING MLAB_DP_CATEG=$DP_CATEG_TESTING MLAB_DP_TIP_ATRI=$DP_TIP_ATRI_TESTING MLAB_DP_CLAS_BIEN=$DP_CLAS_BIEN_TESTING MLAB_DP_CAT_ATRIB=$DP_CAT_ATRIB_TESTING MLAB_DP_ATRIB=$DP_ATRIB_TESTING MLAB_DP_CLAS=$DP_CLAS_TESTING MLAB_DP_TIP_MED=$DP_TIP_MED_TESTING MLAB_DP_MED=$DP_MED_TESTING MLAB_DB_SID=$DB_SID_TESTING MLAB_DB_HOST=$DB_HOST_TESTING MLAB_DB_PORT=$DB_PORT_TESTING MLAB_DB_TYPE=$DB_TYPE_TESTING MLAB_DB_SCHEMA=$DB_SCHEMA_TESTING MLAB_DB_USERNAME=$DB_USERNAME_TESTING MLAB_DB_PASSWORD=$DB_PASSWORD_TESTING MLAB_DB_SYNCRHONIZE=$DB_SYNCRHONIZE_TESTING MLAB_DB_DROPSCHEMA=$DB_DROPSCHEMA_TESTING MLAB_DB_CACHE=$DB_CACHE_TESTING MLAB_DB_DEBUG=$DB_DEBUG_TESTING MLAB_DB_MAX_QET=$DB_MAX_QET_TESTING MLAB_DB_BUFFER_ENTRIES=$DB_BUFFER_ENTRIES_TESTING MLAB_PORT=$PORT_TESTING MLAB_SES_SECRET=$SES_SECRET_TESTING MLAB_RED_PORT=$RED_PORT_TESTING MLAB_RED_HOST=$RED_HOST_TESTING MLAB_SEG_ACTIVAR=$SEG_ACTIVAR_TESTING MLAB_SEG_DB_SCHEMA=$SEG_DB_SCHEMA_TESTING MLAB_AUD_DB_SCHEMA=$AUD_DB_SCHEMA_TESTING npm run start
    - cd ..
    - cd catalogo
    - rm -rf node_modules
    - cd ..
    - sshpass -p $PASSWORD_SSH_APLICACION_TESTING ssh -tt -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30 $USUARIO_SSH_TESTING@$IP_TESTING "cd $DIRECTORIO_APLICACIONES_TESTING && (rm -rf backend || true) && mkdir backend && exit"
    # el -tt es para que no joda que metas el password
    # -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30
    # Estos comandos hacen que no se caiga la conexion
    - sshpass -p $PASSWORD_SSH_APLICACION_TESTING rsync --recursive --compress ./catalogo/ $USUARIO_SSH_TESTING@$IP_TESTING:$DIRECTORIO_APLICACIONES_TESTING/backend/
    - sshpass -p $PASSWORD_SSH_APLICACION_TESTING ssh -tt -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30 $USUARIO_SSH_TESTING@$IP_TESTING "cd $DIRECTORIO_APLICACIONES_TESTING && cd backend && npm i && npm run build && (sudo pm2 stop backend-testing || true) && (sudo pm2 delete backend-testing || true) && sudo pm2 start dist/main.js --name backend-testing && pm2 save"

deploy_master:
  stage: deploy
  when: manual
  only:
    - master
  script:
    - apt-get update -y -qq
    - apt-get -y install rsync -qq
    - apt-get install sshpass
    - cd ..
    - cd ci-cd
    - npm i
    - MLAB_DP_CREAR=$DP_CREAR MLAB_DP_SER_LOG=$DP_SER_LOG MLAB_DP_CONJ=$DP_CONJ MLAB_DP_SUBCONJ=$DP_SUBCONJ MLAB_DP_CATEG=$DP_CATEG MLAB_DP_TIP_ATRI=$DP_TIP_ATRI MLAB_DP_CLAS_BIEN=$DP_CLAS_BIEN MLAB_DP_CAT_ATRIB=$DP_CAT_ATRIB MLAB_DP_ATRIB=$DP_ATRIB MLAB_DP_CLAS=$DP_CLAS MLAB_DP_TIP_MED=$DP_TIP_MED MLAB_DP_MED=$DP_MED MLAB_DB_SID=$DB_SID MLAB_DB_HOST=$DB_HOST MLAB_DB_PORT=$DB_PORT MLAB_DB_TYPE=$DB_TYPE MLAB_DB_SCHEMA=$DB_SCHEMA MLAB_DB_USERNAME=$DB_USERNAME MLAB_DB_PASSWORD=$DB_PASSWORD MLAB_DB_SYNCRHONIZE=$DB_SYNCRHONIZE MLAB_DB_DROPSCHEMA=$DB_DROPSCHEMA MLAB_DB_CACHE=$DB_CACHE MLAB_DB_DEBUG=$DB_DEBUG MLAB_DB_MAX_QET=$DB_MAX_QET MLAB_DB_BUFFER_ENTRIES=$DB_BUFFER_ENTRIES MLAB_PORT=$PORT MLAB_SES_SECRET=$SES_SECRET MLAB_RED_PORT=$RED_PORT MLAB_RED_HOST=$RED_HOST MLAB_SEG_ACTIVAR=$SEG_ACTIVAR MLAB_SEG_DB_SCHEMA=$SEG_DB_SCHEMA MLAB_AUD_DB_SCHEMA=$AUD_DB_SCHEMA npm run start
    - cd ..
    - cd catalogo
    - rm -rf node_modules
    - cd ..
    - sshpass -p $PASSWORD_SSH_APLICACION ssh -tt -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30 $USUARIO_SSH@$IP "cd $DIRECTORIO_APLICACIONES && (rm -rf backend || true) && mkdir backend && exit"
    # el -tt es para que no joda que metas el password
    # -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30
    # Estos comandos hacen que no se caiga la conexion
    - sshpass -p $PASSWORD_SSH_APLICACION rsync --recursive --compress ./catalogo/ $USUARIO_SSH@$IP:$DIRECTORIO_APLICACIONES/backend/
    - sshpass -p $PASSWORD_SSH_APLICACION ssh -tt -o StrictHostKeyChecking=no -o TCPkeepAlive=yes -o ServerAliveInterval=30 $USUARIO_SSH@$IP "cd $DIRECTORIO_APLICACIONES && cd backend && npm i && npm run build && (sudo pm2 stop backend || true) && (sudo pm2 delete backend || true) && sudo pm2 start dist/main.js --name backend && pm2 save"
